Attribute VB_Name = "MLimitEdit"
  Option Private Module
  Option Explicit
  ' demo project showing how to subclass the WM_CHAR and WM_PASTE
  ' messages to limit the text that can be entered into a textbox
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  '
  '   Copyright  2000  Bryan Stafford/New Vision Software
  '
  ' the code in this demo is copyrighted and may only be used in
  ' accordance with the rules set forth in the "House Rules"
  ' section of the web page found at http://www.mvps.org/vbvision/


' the following function calls the window proc in our class object using the
' pointer stored in the property we added to the window when it was subclassed
Public Function LimitEditWindProc(ByVal hWnd&, ByVal uMsg&, ByVal wParam&, ByVal lParam&) As Long
  LimitEditWindProc = cLimitEditFromhWnd(hWnd).WindowProc(hWnd, uMsg, wParam, lParam)
End Function

' for more detailed info on this technique, see the advanced
' subclassing demo at at http://www.mvps.org/vbvision/
Private Function cLimitEditFromhWnd(ByVal hWnd As Long) As cLimitEdit
  ' resolve a dumb pointer into a referenced object....
  
  Dim LimitEditEx As cLimitEdit, pObj As Long
    
  ' retrieve the pointer from the property we set in the subclass routine
  pObj = GetProp(hWnd, ByVal "nvLimitEdit")

  ' copy the pointer into the local variable.  if you end your app durring this
  ' process, vb will crash when it tries to destroy the extra object reference
  ' so don't end your app now.
  CopyMemory LimitEditEx, pObj, 4&
  
  ' set a reference to the object
  Set cLimitEditFromhWnd = LimitEditEx
  
  ' clear the object variable so VB won't try to
  ' decrement the reference count on the object
  CopyMemory LimitEditEx, 0&, 4&
  
End Function

' helper functions....
Public Function LoDWORD(ByVal dblDouble@) As Long
  Dim dwLow&
  CopyMemory ByVal VarPtr(dwLow), ByVal VarPtr(dblDouble), 4&
  LoDWORD = dwLow
End Function

Public Function HiDWORD(ByVal dblDouble@) As Long
  Dim dwHigh&
  CopyMemory ByVal VarPtr(dwHigh), ByVal VarPtr(dblDouble) + 4, 4&
  HiDWORD = dwHigh
End Function

Public Function MAKEDOUBLE(ByVal dwLow&, ByVal dwHigh&) As Currency
  Dim curShiftHigh@
  CopyMemory ByVal VarPtr(curShiftHigh) + 4, ByVal VarPtr(dwHigh), 4&
  CopyMemory ByVal VarPtr(curShiftHigh), ByVal VarPtr(dwLow), 4&
  MAKEDOUBLE = curShiftHigh
End Function

