Attribute VB_Name = "MMain"
  Option Explicit
  ' demo project showing how to subclass the WM_CHAR and WM_PASTE
  ' messages to limit the text that can be entered into a textbox
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  '
  '   Copyright  2000  Bryan Stafford/New Vision Software
  '
  ' the code in this demo is copyrighted and may only be used in
  ' accordance with the rules set forth in the "House Rules"
  ' section of the web page found at http://www.mvps.org/vbvision/


  ' in this project, we implement a global object that can be used to
  ' limit the text entered into any edit control....

  ' module level variable to hold the object for the global property
  Private m_oLimitEditControlEntries As cLimitEdit


  Public Const WM_CONTEXTMENU As Long = &H7B&
  Public Const WM_CHAR As Long = &H102&
  Public Const WM_PASTE As Long = &H302&

  Public Const WM_GETTEXT As Long = &HD&
  Public Const WM_GETTEXTLENGTH As Long = &HE&

  Public Const EM_GETSEL As Long = &HB0&

  Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd&, ByVal lpString$, ByVal hData&) As Long
  Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd&, ByVal lpString$) As Long
  Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd&, ByVal lpString$) As Long

  Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

  ' Window field offsets for GetWindowLong() and GetWindowWord()
  Public Const GWL_WNDPROC As Long = (-4&)

  Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
  Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, ByVal nIndex&, ByVal dwNewLong&) As Long
  
  Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc&, ByVal hWnd&, ByVal Msg&, ByVal wParam&, ByVal lParam&) As Long
  Public Declare Function CallWindowProclParamStr Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc&, ByVal hWnd&, ByVal Msg&, ByVal wParam&, ByVal lParam$) As Long

  Public Declare Function IsWindow Lib "user32" (ByVal hWnd&) As Long

  Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWndParent&, ByVal hWndChildAfter&, ByVal lpClassName$, ByVal lpWindowName$) As Long

Public Property Get g_oLimitEditControlEntries() As cLimitEdit
  ' returns the global object for limiting text entered in a textbox
  
  If m_oLimitEditControlEntries Is Nothing Then
    Set m_oLimitEditControlEntries = New cLimitEdit
  End If
  
  Set g_oLimitEditControlEntries = m_oLimitEditControlEntries

End Property

Private Sub Main()
  ' application entry point
  
  ' create and show our form....
  Dim oFrm As frmLimitEdit
  
  Set oFrm = New frmLimitEdit
  
  ' show the form modally so that we can clean up after the form exits.
  ' this technique is use here for convienience since it allows us to
  ' explicitly clean up the limit text object.
  oFrm.Show vbModal

  Set oFrm = Nothing
  
  
  ' make sure the object gets cleaned up....
  If Not m_oLimitEditControlEntries Is Nothing Then Set m_oLimitEditControlEntries = Nothing

End Sub
